#
# This Makefile sets variables that contain the sources in each
# directory.
#
# Author: Devin Kowatch
# $Id: Makefile.inc,v 1.15.2.9 2003/04/30 20:03:03 devink Exp $
#
# Copyright 2002-2003 
#     The Regents of the University of California. All Rights Reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
# 
#     * Neither the name of the The Regents of the University of
#       California nor the names of its contributors may be used to
#       endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
# OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

## Each makefile that uses this must define main_srcdir as the location of 
## the base directroy for syslogd soruce 

## Each subdirectory  should list its source/header files in a variable
## named {SOURCES,HEADERS}_<subdir>.  The slightly backwards name avoids
## problems with automake (which gives special meaning to
## <blah>_SOURCES/<blah>_HEADERS
## 

# ipc/  
SOURCES_IPC = \
	$(main_srcdir)/ipc/buffer.c 		\
	$(main_srcdir)/ipc/inputwait.c 		\
	$(main_srcdir)/ipc/ipc.c 			\
	$(main_srcdir)/ipc/ipc_cstate.c 	\
	$(main_srcdir)/ipc/ipc_ctl.c 		\
	$(main_srcdir)/ipc/ipc_err.c		\
	$(main_srcdir)/ipc/ipc_pkt.c		\
	$(main_srcdir)/ipc/ipc_queue.c		\
	$(main_srcdir)/ipc/ipc_sig.c		\
	$(main_srcdir)/ipc/ipcll.c			\
	$(main_srcdir)/ipc/ipc_lock.c	

HEADERS_IPC = \
	$(main_srcdir)/ipc/buffer.h			\
	$(main_srcdir)/ipc/inputwait.h		\
	$(main_srcdir)/ipc/ipc.h			\
	$(main_srcdir)/ipc/ipc_cstate.h		\
	$(main_srcdir)/ipc/ipc_ctl.h		\
	$(main_srcdir)/ipc/ipc_err.h		\
	$(main_srcdir)/ipc/ipc_pkt.h		\
	$(main_srcdir)/ipc/ipc_private.h	\
	$(main_srcdir)/ipc/ipc_sig.h		\
	$(main_srcdir)/ipc/ipc_types.h		\
	$(main_srcdir)/ipc/ipcll.h			\
	$(main_srcdir)/ipc/ipc_lock.h	

## config/
## This just uses a library due to problems building lex source in 
## subdirectories.  Using automake 1.6.2 will fix these problems.


## message/
## This just uses a library due to problems building lex source in 
## subdirectories.  Using automake 1.6.2 will fix these problems.
##SOURCES_MSG =\
##	$(main_srcdir)/message/message.c			\
##	$(main_srcdir)/message/msg_parse_rfc3164.c	\
##	$(main_srcdir)/message/msg_frmt_read.c		\
##	$(main_srcdir)/message/msg_parse_cooked.c	\
##	$(main_srcdir)/message/syslog_cooked.c		\
##	$(main_srcdir)/message/msg_parse.c
##
##HEADERS_MSG = \
##	$(main_srcdir)/message/message.h			\
##	$(main_srcdir)/message/msg_parse_rfc3164.h	\
##	$(main_srcdir)/message/msg_frmt_read.c		\
##	$(main_srcdir)/message/msg_parse_cooked.h	\
##	$(main_srcdir)/message/syslog_cooked.h		\
##	$(main_srcdir)/message/msg_parse.h			

# util/
SOURCES_UTIL =  \
	$(main_srcdir)/util/acl.c		\
	$(main_srcdir)/util/avltree.c	\
	$(main_srcdir)/util/debug.c		\
	$(main_srcdir)/util/error.c		\
	$(main_srcdir)/util/list.c		\
	$(main_srcdir)/util/netaddr.c	\
	$(main_srcdir)/util/pathcache.c	\
	$(main_srcdir)/util/privs.c		\
	$(main_srcdir)/util/test.c		\
	$(main_srcdir)/util/hashtable.c \
	$(main_srcdir)/util/exiterr.c	\
	$(main_srcdir)/util/log.c		\
	$(main_srcdir)/util/tsqueue.c

HEADERS_UTIL = \
	$(main_srcdir)/util/acl.h			\
	$(main_srcdir)/util/acl_private.h	\
	$(main_srcdir)/util/avltree.h		\
	$(main_srcdir)/util/list.h			\
	$(main_srcdir)/util/list_private.h	\
	$(main_srcdir)/util/netaddr.h		\
	$(main_srcdir)/util/pathcache.h		\
	$(main_srcdir)/util/hashtable.h		\
	$(main_srcdir)/util/bitvec.h		\
	$(main_srcdir)/util/tsqueue.h	

#outputmod/
SOURCES_OM = \
	$(main_srcdir)/outputmod/outputmod.c	\
	$(main_srcdir)/outputmod/omod_fread.c	\
	$(main_srcdir)/outputmod/omod_udp.c		\
	$(main_srcdir)/outputmod/omod_user.c

HEADERS_OM = \
	$(main_srcdir)/outputmod/omod_init.h	\
	$(main_srcdir)/outputmod/outputmod.h	

# inputmod/
SOURCES_IM = \
	$(main_srcdir)/inputmod/imod_udp.c	\
	$(main_srcdir)/inputmod/inputmod.c 	\
	$(main_srcdir)/inputmod/imod_mark.c	

HEADERS_IM = \
	$(main_srcdir)/inputmod/inputmod.h 	\
	$(main_srcdir)/inputmod/system.h	

# Controller
SOURCES_CTLR = \
	$(main_srcdir)/controller/controller.c		\
	$(main_srcdir)/controller/ctlr_config.c		\
	$(main_srcdir)/controller/ctlr_util.c		\
	$(main_srcdir)/controller/ctlr_destroy.c	

HEADERS_CTLR = \
	$(main_srcdir)/controller/controller.h		\
	$(main_srcdir)/controller/ctlr_config.h		\
	$(main_srcdir)/controller/ctlr_destroy.h	

# include/ (headers only)
HEADERS_INC = \
	$(main_srcdir)/include/error.h		\
	$(main_srcdir)/include/types.h		\
	$(main_srcdir)/include/strcompat.h	\
	$(main_srcdir)/include/debug.h		\
	$(main_srcdir)/include/log.h		\
	$(main_srcdir)/include/privs.h		\
	$(main_srcdir)/include/test.h		\
	$(main_srcdir)/include/chaninfo.h	\
	$(main_srcdir)/include/dmalloc_sup.h

# Stuff for BEEP, which can be conditionally compiled in.
if HAVE_LIBRR
HEADERS_BEEP = \
    $(main_srcdir)/util/profile-beep.h

SOURCES_BEEP = \
    $(main_srcdir)/util/profile-beep.c  \
    $(main_srcdir)/outputmod/omod_beep.c\
	$(main_srcdir)/inputmod/imod_beep.c
else
HEADERS_BEEP =
SOURCES_BEEP =
endif

    

# Special rules for making const.h
BUILT_SOURCES = \
	$(main_srcdir)/include/const.h 	\
	$(main_srcdir)/include/version.h

$(main_srcdir)/include/const.h: $(main_srcdir)/include/const.h.in \
  $(top_builddir)/config.status
	rm -f $@ 
	sed -e 's,@sysconfdir\@,$(sysconfdir),' \
		-e 's,@localstatedir\@,$(localstatedir),'\
		-e 's,@pkgdatadir\@,$(pkgdatadir),' \
		$< > $@

# The dependency list still doesn't work correctly.  I want it to
# rebuild anytime syslogd is rebuilt.
$(main_srcdir)/include/version.h: $(main_srcdir)/include/version.h.in \
    $(top_srcdir)/vers.sh  $(top_srcdir)/VERSION
	rm -f $@
	$(top_srcdir)/vers.sh --top_srcdir="$(top_srcdir)" "$@.in"

