/* A Bison parser, made from /usr/tmp/sdscsyslog_mkrel.7bFK0T/sdscsyslog/src/config/confparse.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse conf_parse
#define yylex conf_lex
#define yyerror conf_error
#define yylval conf_lval
#define yychar conf_char
#define yydebug conf_debug
#define yynerrs conf_nerrs
# define	T_ID	257
# define	T_STRING	258
# define	T_FLOAT	259
# define	T_INT	260
# define	T_OPENSCOPE	261
# define	T_CLOSESCOPE	262
# define	T_SEMI	263
# define	T_QUOTE	264
# define	T_COMMA	265
# define	T_DOT	266
# define	T_EQUALS	267
# define	T_DASH	268
# define	T_STAR	269
# define	T_OUTPUT	270
# define	T_INPUT	271
# define	T_ACL	272
# define	T_VERSION	273
# define	T_TYPE	274
# define	T_LISTEN	275
# define	T_PORT	276
# define	T_FORMAT	277
# define	T_FOPTS	278
# define	T_OUTPATH	279
# define	T_PRIORITY	280
# define	T_CONNECT	281
# define	T_TO	282
# define	T_GLOBAL	283
# define	T_USER	284
# define	T_GROUP	285
# define	T_DBGFILE	286
# define	T_SOCKPATH	287

#line 48 "confparse.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include "error.h"
#include "strcompat.h"
#include "log.h"
#include "util/netaddr.h"
#include "util/list.h"
#include "util/acl.h"
#include "util/bitvec.h"

#include "message/msg_frmt.h"

#include "chaninfo.h"
#include "config.h"
#include "conf_private.h"
#include "conf_obj.h"

#include "debug.h"

static char const rcsid[]
    = "$Id: confparse.y,v 1.45.2.7 2003/04/30 20:03:07 devink Exp $";

/* to match defines generated by lex/flex */
#define yylex conf_lex

/* prototypes for functions created by lex/flex */
int yylex(void);
void yyerror(char *s);

#if ENABLE_DEBUG
/* enable the possibility of debugging, turn on with 'yydebug=1' */
#define YYDEBUG 1

/* There are still some problems with YACC debugging, like where to turn
 * on yydebug (conf_debug here) and how to do it in such a way that
 * doesn't break unit tests without libconfig linked in.
 */
#if 0
#define YYFPRINTF(junk, fmt, ...)   \
    DBG_print(DBG_CNF, fmt, __FILE__, __LINE__, ##__VA_ARGS__)
#endif
#endif /* ENABLE_DEBUG */

/** Severity map; see CONFFS_sevlen for the length of the array */
struct CONFFS_str CONFFS_sev[] =
{
	{ "emerg", CONFFS_EMERG, },		/**< Emergency severity */
	{ "panic", CONFFS_EMERG, },		/**< Deprecated; Emergency severity */
	{ "alert", CONFFS_ALERT, },		/**< Alert severity */
	{ "crit", CONFFS_CRIT, },		/**< Critical severity */
	{ "error", CONFFS_ERR, },		/**< Deprecated; Error severity */
	{ "err", CONFFS_ERR, },			/**< Error severity */
	{ "warn", CONFFS_WARN, },		/**< Warning severity */
	{ "warning", CONFFS_WARN, },	/**< Deprecated; Warning severity */
	{ "notice", CONFFS_NOTICE, },	/**< Notice severity */
	{ "info", CONFFS_INFO, },		/**< Informational severity */
	{ "debug", CONFFS_DEBUG, },		/**< Debug severity */
	{ "none", -1, },				/**< Internal; no severity */
};

/** Length of the CONFFS_sev */
#define CONFFS_sevlen	(sizeof(CONFFS_sev)/sizeof(struct CONFFS_str))

/** Facility map; see CONFFS_faclen for the length of the array */
struct CONFFS_str CONFFS_fac[] =
{
    { "kern", CONFFS_KERN, },       /**< Map 'kern' to kernel facility */
	{ "kernel", CONFFS_KERN, },		/**< Alias: 'kernel' -> 'kern' */
	{ "user", CONFFS_USER, },		/**< Map 'user' to user facility */
	{ "mail", CONFFS_MAIL, },		/**< Map 'mail' to mail facility */
	{ "daemon", CONFFS_DAEMON, },	/**< Map 'daemon' to daemon facility */
	{ "auth", CONFFS_AUTH0, },		/**< Map 'auth' to auth0 facility */
	{ "auth0", CONFFS_AUTH0, },		/**< Map 'auth0' to auth0 facility */
	{ "syslog", CONFFS_SYSLOG, },	/**< Map 'syslog' to syslog facility */
	{ "lpr", CONFFS_LPR, },			/**< Map 'lpr' to LPR facility */
	{ "news", CONFFS_NEWS, },		/**< Map 'news' to news facility */
	{ "uucp", CONFFS_UUCP, },		/**< Map 'uucp' to UUCP facility */
	{ "cron", CONFFS_CRON0, },		/**< Map 'cron' to cron0 facility */
	{ "cron0", CONFFS_CRON0, },		/**< Map 'cron0' to cron0 facility */
    { "authpriv", CONFFS_AUTH1},    /**< Linux: 'authpriv' -> auth1 */
	{ "auth1", CONFFS_AUTH1, }	,	/**< Map 'auth1' to auth1 facility */
	{ "ftp", CONFFS_FTP, },			/**< Map 'ftp' to ftp facility */
	{ "ntp", CONFFS_NTP, },			/**< Map 'ntp' to ntp facility */
	{ "audit", CONFFS_AUDIT0, },	/**< Map 'audit' to audit0 facility */
	{ "audit0", CONFFS_AUDIT0, },	/**< Map 'audit0' to audit0 facility */
	{ "audit1", CONFFS_AUDIT1, },	/**< Map 'audit1' to audit1 facility */
	{ "cron1", CONFFS_CRON1, },		/**< Map 'cron1' to cron1 facility */
	{ "local0", CONFFS_LOCAL0, },	/**< Map 'local0' to local0 facility */
	{ "local1", CONFFS_LOCAL1, },	/**< Map 'local1' to local1 facility */
	{ "local2", CONFFS_LOCAL2, },	/**< Map 'local2' to local2 facility */
	{ "local3", CONFFS_LOCAL3, },	/**< Map 'local3' to local3 facility */
	{ "local4", CONFFS_LOCAL4, },	/**< Map 'local4' to local4 facility */
	{ "local5", CONFFS_LOCAL5, },	/**< Map 'local5' to local5 facility */
	{ "local6", CONFFS_LOCAL6, },	/**< Map 'local6' to local6 facility */
	{ "local7", CONFFS_LOCAL7, },	/**< Map 'local7' to local7 facility */
    { "mark", CONFFS_MARK},         /**< Map 'mark' to internal mark facility*/
};

/** Length of the CONFFS_fac array */
#define CONFFS_faclen	(sizeof(CONFFS_fac)/sizeof(struct CONFFS_str))

/**@name tri-state values used to build the priority_list. 
 * @{
 */
#define PRI_UNSET   0   /**< No value */
#define PRI_PASS    1   /**< This priority gets sent out */
#define PRI_DROP    2   /**< This priority will be dropped */
/*@}*/

/** Error string */
static char CONFPRV_errstr[1024];

/**
 * Function to parse Severity ranges.  This is needed in this file due
 * to needing to access CONFFS_sev and since T_ID can contain a '-' it
 * is a large chunck of code that I'd rather not just duplicate in the 
 * severity_list rule.
 *
 * @param rstr The right side severity.
 * @param lstr The Left side severity.
 * @param pris The priority array.
 * @return 0 on success, non-zero other wise.
 */
int parseSevRange(char const *rstr, char const *lstr, int* pris);


#line 183 "confparse.y"
#ifndef YYSTYPE
typedef union {
	char 	*sval;
	int		ival;
	int 	*ipntr;
	float	fval;
    List    list;
	struct	inchan_info *input_conf;
	struct	outchan_info *output_conf;
	struct	CONF_con *connect_conf;
	struct	CONF_global *global_conf;
	struct	CONFPRV_version ver;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		132
#define	YYFLAG		-32768
#define	YYNTBASE	34

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 287 ? yytranslate[x] : 62)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     5,    11,    12,    17,    18,    23,    24,
      29,    30,    35,    36,    42,    46,    50,    54,    55,    61,
      65,    69,    73,    77,    81,    85,    89,    90,    93,    96,
      99,   104,   108,   112,   113,   118,   124,   125,   127,   129,
     133,   135,   138,   142,   144,   147,   152,   156,   157,   160,
     163,   166,   171,   176,   181,   186,   191
};
static const short yyrhs[] =
{
      -1,    36,    35,    37,     0,    19,     6,    12,     6,     9,
       0,     0,    42,    38,     9,    37,     0,     0,    44,    39,
       9,    37,     0,     0,    59,    40,     9,    37,     0,     0,
      60,    41,     9,    37,     0,     0,    17,     3,     7,    43,
       8,     0,    46,     9,    43,     0,    57,     9,    43,     0,
      58,     9,    43,     0,     0,    16,     3,     7,    45,     8,
       0,    46,     9,    45,     0,    54,     9,    45,     0,    55,
       9,    45,     0,    47,     9,    45,     0,    48,     9,    45,
       0,    50,     9,    45,     0,    58,     9,    45,     0,     0,
      20,     3,     0,    25,     3,     0,    25,     4,     0,    25,
       7,    49,     8,     0,     3,     9,    49,     0,     4,     9,
      49,     0,     0,    26,     7,    51,     8,     0,    52,    12,
      53,     9,    51,     0,     0,     3,     0,    15,     0,     3,
      11,    52,     0,     3,     0,    13,     3,     0,     3,    14,
       3,     0,    15,     0,    23,     3,     0,    24,     7,    56,
       8,     0,     3,     9,    56,     0,     0,    21,     3,     0,
      21,     4,     0,    22,     6,     0,    27,     3,    28,     3,
       0,    29,     7,    61,     8,     0,     3,     4,     9,    61,
       0,     3,     3,     9,    61,     0,     3,     6,     9,    61,
       0,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   264,   264,   298,   306,   306,   312,   312,   317,   317,
     322,   322,   332,   335,   390,   445,   454,   460,   466,   496,
     513,   539,   544,   551,   558,   571,   577,   583,   590,   596,
     603,   610,   618,   624,   632,   649,   681,   688,   723,   733,
     773,   854,   895,   908,   920,   927,   933,   953,   959,   964,
     970,   977,  1018,  1025,  1039,  1052,  1064
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "T_ID", "T_STRING", "T_FLOAT", "T_INT", 
  "T_OPENSCOPE", "T_CLOSESCOPE", "T_SEMI", "T_QUOTE", "T_COMMA", "T_DOT", 
  "T_EQUALS", "T_DASH", "T_STAR", "T_OUTPUT", "T_INPUT", "T_ACL", 
  "T_VERSION", "T_TYPE", "T_LISTEN", "T_PORT", "T_FORMAT", "T_FOPTS", 
  "T_OUTPATH", "T_PRIORITY", "T_CONNECT", "T_TO", "T_GLOBAL", "T_USER", 
  "T_GROUP", "T_DBGFILE", "T_SOCKPATH", "cfg", "@1", "version", 
  "definitions", "@2", "@3", "@4", "@5", "input", "input_decls", "output", 
  "output_decls", "type_decl", "outpath_decl", "outpath_list_decl", 
  "outpath_list", "priority_decl", "priority_list", "facility_list", 
  "severity_list", "format_decl", "format_opts_decl", "format_opt_list", 
  "listen_decl", "port_decl", "connect", "global", "global_decls", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    35,    34,    36,    38,    37,    39,    37,    40,    37,
      41,    37,    37,    42,    43,    43,    43,    43,    44,    45,
      45,    45,    45,    45,    45,    45,    45,    46,    47,    47,
      48,    49,    49,    49,    50,    51,    51,    52,    52,    52,
      53,    53,    53,    53,    54,    55,    56,    56,    57,    57,
      58,    59,    60,    61,    61,    61,    61
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     3,     5,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     5,     3,     3,     3,     0,     5,     3,
       3,     3,     3,     3,     3,     3,     0,     2,     2,     2,
       4,     3,     3,     0,     4,     5,     0,     1,     1,     3,
       1,     2,     3,     1,     2,     4,     3,     0,     2,     2,
       2,     4,     4,     4,     4,     4,     0
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     0,     1,     0,    12,     0,     0,     0,     0,     0,
       2,     4,     6,     8,    10,     0,     0,     0,     0,    56,
       0,     0,     0,     0,     3,    26,    17,     0,     0,     0,
      12,    12,    12,    12,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    51,     0,     0,     0,    52,     5,     7,
       9,    11,    27,    50,    44,    47,    28,    29,    33,    36,
      18,    26,    26,    26,    26,    26,    26,    26,    48,    49,
      13,    17,    17,    17,    56,    56,    56,     0,     0,     0,
       0,     0,    37,    38,     0,     0,    19,    22,    23,    24,
      20,    21,    25,    14,    15,    16,    54,    53,    55,    47,
      45,    33,    33,    30,     0,    34,     0,    46,    31,    32,
      39,    40,     0,    43,     0,     0,    41,    36,    42,    35,
       0,     0,     0
};

static const short yydefgoto[] =
{
     130,     4,     2,    10,    20,    21,    22,    23,    11,    49,
      12,    40,    41,    42,    43,    91,    44,    94,    95,   124,
      45,    46,    88,    51,    47,    13,    14,    29
};

static const short yypact[] =
{
      -8,     7,-32768,    14,   -15,    34,    45,    51,    58,    55,
  -32768,-32768,-32768,-32768,-32768,    54,    57,    59,    37,    64,
      60,    61,    62,    63,-32768,     5,    22,    65,    35,    66,
     -15,   -15,   -15,   -15,    70,    69,    73,    71,     3,    72,
      74,    68,    75,    76,    77,    78,    79,    80,    29,    82,
      83,    84,    85,-32768,    86,    87,    88,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    95,-32768,-32768,    49,     1,
  -32768,     5,     5,     5,     5,     5,     5,     5,-32768,-32768,
  -32768,    22,    22,    22,    64,    64,    64,    90,    92,    93,
      94,    96,    97,-32768,    98,    89,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    95,
  -32768,    49,    49,-32768,     1,-32768,     2,-32768,-32768,-32768,
  -32768,    67,   102,-32768,   100,   104,-32768,     1,-32768,-32768,
      91,   110,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,     4,-32768,-32768,-32768,-32768,-32768,   -36,
  -32768,   -53,   -26,-32768,-32768,  -103,-32768,   -47,   -31,-32768,
  -32768,-32768,     6,-32768,   -23,-32768,-32768,   -35
};


#define	YYLAST		115


static const short yytable[] =
{
      50,     6,     7,    52,    92,   121,    66,    67,   118,   119,
      68,     1,     8,     3,     9,   122,    93,   123,    96,    97,
      98,    99,   100,   101,   102,    34,     5,    35,    36,    37,
      38,    39,    78,    79,    58,    59,    60,    61,    54,    55,
      15,    56,    34,    48,    35,   103,   104,   105,    16,   106,
     107,   108,    89,    90,    17,    50,    50,    50,    52,    52,
      52,    18,    19,    24,    25,    27,    26,    28,    53,    30,
      31,    32,    33,    62,    57,    63,    64,    71,    65,    69,
     129,   125,    70,   120,    72,    73,    74,    75,    76,    77,
      80,   131,    81,    82,    83,    84,    85,    86,    87,   109,
     110,   116,   111,   112,   113,   126,   115,   128,   114,   127,
     132,     0,     0,     0,     0,   117
};

static const short yycheck[] =
{
      26,    16,    17,    26,     3,     3,     3,     4,   111,   112,
       7,    19,    27,     6,    29,    13,    15,    15,    71,    72,
      73,    74,    75,    76,    77,    20,    12,    22,    23,    24,
      25,    26,     3,     4,    30,    31,    32,    33,     3,     4,
       6,     6,    20,    21,    22,    81,    82,    83,     3,    84,
      85,    86,     3,     4,     3,    81,    82,    83,    81,    82,
      83,     3,     7,     9,     7,    28,     7,     3,     3,     9,
       9,     9,     9,     3,     8,     6,     3,     9,     7,     7,
     127,    14,     8,   114,     9,     9,     9,     9,     9,     9,
       8,     0,     9,     9,     9,     9,     9,     9,     3,     9,
       8,    12,     9,     9,     8,     3,     8,     3,    11,     9,
       0,    -1,    -1,    -1,    -1,   109
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 266 "confparse.y"
{
			/* if the version isn't recognized, exit */
            if (yyvsp[0].ver.major != CONFPRV_majver) {
                snprintf(CONFPRV_errstr, 1024, 
                    "Required Major Version %d was not found."
                    " Config file has version %d.%d. Config files are"
                    " not compatable across major versions", 
                    CONFPRV_majver, yyvsp[0].ver.major, yyvsp[0].ver.minor);
                yyerror(CONFPRV_errstr);
                return 1;
            }
            else if (yyvsp[0].ver.minor > CONFPRV_minver) {
                snprintf(CONFPRV_errstr, 1024, 
                    "Config file's minor version is greater than"
                    " expected.  Lastest parsable version is %d.%d,"
                    " config file is version %d.%d",
                    CONFPRV_majver, CONFPRV_minver, yyvsp[0].ver.major, yyvsp[0].ver.minor);
                yyerror(CONFPRV_errstr);
                return 1;
            }
            else if (yyvsp[0].ver.minor < CONFPRV_minver) {
                LOG_print(LOG_INFO, "Config file out of date but"
                    " compatable.  Note that some options might be"
                    " depreciated. Lastest parser version is %d.%d",
                    CONFPRV_majver, CONFPRV_minver);
            }
		}
    break;
case 2:
#line 294 "confparse.y"
{
		}
    break;
case 3:
#line 300 "confparse.y"
{
			yyval.ver.major=yyvsp[-3].ival;
			yyval.ver.minor=yyvsp[-1].ival;
		}
    break;
case 4:
#line 308 "confparse.y"
{
			CONFSYM_addInput(yyvsp[0].input_conf);
		}
    break;
case 6:
#line 313 "confparse.y"
{
			CONFSYM_addOutput(yyvsp[0].output_conf);
		}
    break;
case 8:
#line 318 "confparse.y"
{
			CONFSYM_addConnect(yyvsp[0].connect_conf);
		}
    break;
case 10:
#line 323 "confparse.y"
{
			if(!CONFSYM_addGlobal(yyvsp[0].global_conf))
			{
				yyerror("Multiple global declarations found");

				return 1;
			}
		}
    break;
case 13:
#line 337 "confparse.y"
{
			yyvsp[-1].input_conf->name=yyvsp[-3].sval;

			/* we must have some sort of an input path; if there's no default,
			 * and one wasn't specified, we error. The expection is the
             * mark input module which has no input path.
             */
			if(NULL==yyvsp[-1].input_conf->inPath && yyvsp[-1].input_conf->type != IMOD_MARK)
			{
				snprintf(CONFPRV_errstr,1024,
						"listen option required in input %s",
						yyvsp[-1].input_conf->name);
				yyerror(CONFPRV_errstr);
				return 1;
			}

			/* also, let's create the addr, depending on the type */
			switch (yyvsp[-1].input_conf->type)
			{
				case IMOD_UDP:
				case IMOD_BEEP:
					if(NULL==(yyvsp[-1].input_conf->inAddr=CONFPRV_parseIP(yyvsp[-1].input_conf->inPath)))
					{
						snprintf(CONFPRV_errstr,1024,
							"invalid address (%s) in input %s",
							yyvsp[-1].input_conf->inPath,yyvsp[-1].input_conf->name);
						yyerror(CONFPRV_errstr);
						return 1;
					}

					break;

				case IMOD_SYSTEM:
					yyvsp[-1].input_conf->inAddr=NA_newUnix(yyvsp[-1].input_conf->inPath);
					
					break;
                case IMOD_MARK:
                    /* NOTHING TO DO */
                    break;

				default:
					snprintf(CONFPRV_errstr,1024,
							"unrecognized input type (%d) in input %s",
							yyvsp[-1].input_conf->type,yyvsp[-1].input_conf->name);
					yyerror(CONFPRV_errstr);
					return 1;
					break;	/* never reached */
			}

			yyval.input_conf=yyvsp[-1].input_conf;
		}
    break;
case 14:
#line 392 "confparse.y"
{
			/* detect the type, and add any defaults */
			if(0==strncmp(yyvsp[-2].sval,"beep",4))
			{
				yyvsp[0].input_conf->type=IMOD_BEEP;

				if(-1==yyvsp[0].input_conf->inPort)
					yyvsp[0].input_conf->inPort=SYSLOG_CONN_PORT;
				if(NULL==yyvsp[0].input_conf->inPath)
				{
					yyvsp[0].input_conf->inPath=emalloc(sizeof(char)*(strlen("0.0.0.0")+1));
					strlcpy(yyvsp[0].input_conf->inPath,"0.0.0.0",strlen("0.0.0.0")+1);
				}
			}
			else if(0==strncmp(yyvsp[-2].sval,"udp",4))
			{
				yyvsp[0].input_conf->type=IMOD_UDP;

				if(-1==yyvsp[0].input_conf->inPort)
					yyvsp[0].input_conf->inPort=SYSLOG_UDP_PORT;
				if(NULL==yyvsp[0].input_conf->inPath)
				{
					yyvsp[0].input_conf->inPath=emalloc(sizeof(char)*(strlen("0.0.0.0")+1));
					strlcpy(yyvsp[0].input_conf->inPath,"0.0.0.0",strlen("0.0.0.0")+1);
				}
			}
			else if(0==strncmp(yyvsp[-2].sval,"system",7))
			{
				yyvsp[0].input_conf->type=IMOD_SYSTEM;

				if(NULL==yyvsp[0].input_conf->inPath)
				{
					yyvsp[0].input_conf->inPath=emalloc(sizeof(char)*
							(strlen(DEFAULT_SYS_SOCKET)+1));
					strlcpy(yyvsp[0].input_conf->inPath,DEFAULT_SYS_SOCKET,
							strlen(DEFAULT_SYS_SOCKET)+1);
				}
			}
            else if (0==strncmp(yyvsp[-2].sval, "mark", 5))
            {
                yyvsp[0].input_conf->type=IMOD_MARK;
            }
			else	/* we need to report an error */
			{
				snprintf(CONFPRV_errstr,1024,"invalid input type: \"%s\"",yyvsp[-2].sval);
				yyerror(CONFPRV_errstr);

				return 1;
			}

			free(yyvsp[-2].sval);
			yyval.input_conf=yyvsp[0].input_conf;
		}
    break;
case 15:
#line 446 "confparse.y"
{
			if(NULL!=yyvsp[0].input_conf->inPath)
				free(yyvsp[0].input_conf->inPath);

			yyvsp[0].input_conf->inPath=yyvsp[-2].sval;

			yyval.input_conf=yyvsp[0].input_conf;
		}
    break;
case 16:
#line 455 "confparse.y"
{
			yyvsp[0].input_conf->inPort=yyvsp[-2].ival;

			yyval.input_conf=yyvsp[0].input_conf;
		}
    break;
case 17:
#line 461 "confparse.y"
{
			yyval.input_conf=CONFOBJ_createInput();
		}
    break;
case 18:
#line 468 "confparse.y"
{
			yyvsp[-1].output_conf->name=yyvsp[-3].sval;

            /* Check for and log and clear invalid formatter options 
             * Bad options are not considerd fatal, so we just ignore
             * the return.
             */
            MFRMT_checkOptions(&(yyvsp[-1].output_conf->opts->format), 
                CONFPRV_fname(), CONFPRV_lineno());

            /* Do final output module specific validation of the
             * options.  A FALSE return indicates that there was a big
             * problem, and we are going to bail.
             */
            if (! OMOD_processOptions(yyvsp[-1].output_conf->type, yyvsp[-1].output_conf->opts, 
                    CONFPRV_fname(), CONFPRV_lineno()))
            {
                snprintf(CONFPRV_errstr, 1024,
                    "Fatal error processing options for output module %s",
                    yyvsp[-1].output_conf->name);
                yyerror(CONFPRV_errstr);
                return 1;
            }

			yyval.output_conf=yyvsp[-1].output_conf;
		}
    break;
case 19:
#line 498 "confparse.y"
{
            yyvsp[0].output_conf->type = OMOD_getTypeByName(yyvsp[-2].sval);

            if (yyvsp[0].output_conf->type == OMOD_COUNT) 
			{
				snprintf(CONFPRV_errstr,1024,"invalid output type: \"%s\"",yyvsp[-2].sval);
				yyerror(CONFPRV_errstr);

				/* return with an error */
				return 1;
			}

			free(yyvsp[-2].sval);
			yyval.output_conf=yyvsp[0].output_conf;
		}
    break;
case 20:
#line 514 "confparse.y"
{
            MFRMT_TYPE  type;

            if (yyvsp[0].output_conf->opts->format.type != 0) 
            {
                yyerror("Can't specify two formatters in one output block");
                return 1;
            }

            type = MFRMT_getType(yyvsp[-2].sval);
            if (type == MFRMT_NOEXIST)
			{
				snprintf(CONFPRV_errstr,1024,"invalid format type: \"%s\"",yyvsp[-2].sval);
				yyerror(CONFPRV_errstr);

				/* return with an error */
				return 1;
			}

            /* Set the type */
            yyvsp[0].output_conf->opts->format.type = type;

			free(yyvsp[-2].sval);
			yyval.output_conf=yyvsp[0].output_conf;
		}
    break;
case 21:
#line 540 "confparse.y"
{
            yyvsp[0].output_conf->opts->format.options = BM_UNION(yyvsp[0].output_conf->opts->format.options, yyvsp[-2].ival);
            yyval.output_conf=yyvsp[0].output_conf;
        }
    break;
case 22:
#line 545 "confparse.y"
{
            DPRINT(DBG_CNF, "Reducing outpath_decl, String %s", yyvsp[-2].sval);
			yyvsp[0].output_conf->opts->outPath=yyvsp[-2].sval;

			yyval.output_conf=yyvsp[0].output_conf;
		}
    break;
case 23:
#line 552 "confparse.y"
{
            DPRINT(DBG_CNF, "Reducing outpath_list_decl", NO_VARG);
            yyvsp[0].output_conf->opts->outList=yyvsp[-2].list;

            yyval.output_conf=yyvsp[0].output_conf;
        }
    break;
case 24:
#line 559 "confparse.y"
{
			int i;

			for(i=0;i<PRIORITY_COUNT;i++)
			{
				if(yyvsp[-2].ipntr[i])
					yyvsp[0].output_conf->pri[i]=1;
			}

			yyval.output_conf=yyvsp[0].output_conf;
            free(yyvsp[-2].ipntr);
		}
    break;
case 25:
#line 572 "confparse.y"
{
			yyvsp[0].output_conf->opts->outPort=yyvsp[-2].ival;

			yyval.output_conf=yyvsp[0].output_conf;
		}
    break;
case 26:
#line 578 "confparse.y"
{
			yyval.output_conf=CONFOBJ_createOutput();
		}
    break;
case 27:
#line 585 "confparse.y"
{
			yyval.sval=yyvsp[0].sval;
		}
    break;
case 28:
#line 592 "confparse.y"
{
            DPRINT(DBG_CNF, "outpath_decl: Got ID %s", yyvsp[0].sval);
			yyval.sval=yyvsp[0].sval;
		}
    break;
case 29:
#line 597 "confparse.y"
{
            DPRINT(DBG_CNF, "outpath_decl: Got string: %s", yyvsp[0].sval);
			yyval.sval=yyvsp[0].sval;
		}
    break;
case 30:
#line 605 "confparse.y"
{
            yyval.list=yyvsp[-1].list;
        }
    break;
case 31:
#line 612 "confparse.y"
{
            DPRINT(DBG_CNF, "outpath_list: Adding id to list: %s", yyvsp[-2].sval);
            LL_append(yyvsp[0].list, yyvsp[-2].sval);

            yyval.list = yyvsp[0].list;
        }
    break;
case 32:
#line 619 "confparse.y"
{
            DPRINT(DBG_CNF, "outpath_list: Adding string to list: %s", yyvsp[-2].sval);
            LL_append(yyvsp[0].list, yyvsp[-2].sval);
            yyval.list = yyvsp[0].list;
        }
    break;
case 33:
#line 625 "confparse.y"
{
            DPRINT(DBG_CNF, "outpath_list: new list", NO_VARG);
            yyval.list = LL_create();
        }
    break;
case 34:
#line 634 "confparse.y"
{
            int   i;
            /* this does final cleanup on the priority list, which is
             * supposed to only contain TRUE or FALSE.  
             */
            for (i=0; i < PRIORITY_COUNT; i++) {
                if (yyvsp[-1].ipntr[i] == PRI_UNSET || yyvsp[-1].ipntr[i] == PRI_DROP)
                    yyvsp[-1].ipntr[i] = 0;  /* PRI_UNSET or PRI_DROP -> FALSE */
                else
                    yyvsp[-1].ipntr[i] = 1;  /* PRI_PASS -> TRUE */
            }
	  		yyval.ipntr=yyvsp[-1].ipntr;
		}
    break;
case 35:
#line 651 "confparse.y"
{
			int     sev, fac;

			for(sev=0;sev<CONFFS_SEVCOUNT;sev++)
			{
                for(fac=0;fac<CONFFS_FACCOUNT;fac++)
                {
                    /* only change the priority list if it contains a 
                     * value of 'UNSET'. 
                     */
                    if(yyvsp[-4].ipntr[fac] && yyvsp[0].ipntr[fac*8+sev] == PRI_UNSET)
                    {
                        /* The state of this priority can be found in
                         * the assocaited severity, which will be either
                         * PRI_UNSET, PRI_DROP, or PRI_PASS, The
                         * severity is left to figure this out b/c it
                         * has the special value of 'none'
                         */ 
                        yyvsp[0].ipntr[fac*8+sev] = yyvsp[-2].ipntr[sev];
                        DPRINT(DBG_CNF, "Setting %d, %d to %d",
                            fac, sev, yyvsp[-2].ipntr[sev]);
                    }
				}
			}

			free(yyvsp[-4].ipntr);
			free(yyvsp[-2].ipntr);

			yyval.ipntr=yyvsp[0].ipntr;
		}
    break;
case 36:
#line 682 "confparse.y"
{
			yyval.ipntr=emalloc(sizeof(int)*PRIORITY_COUNT);
			memset(yyval.ipntr,0,sizeof(int)*PRIORITY_COUNT);
		}
    break;
case 37:
#line 690 "confparse.y"
{
			int i=0;

			yyval.ipntr=emalloc(sizeof(int)*CONFFS_FACCOUNT);
			memset(yyval.ipntr,0,CONFFS_FACCOUNT*sizeof(int));

			for(i=0;i<CONFFS_faclen;i++)
			{
				if(0==strncmp(yyvsp[0].sval,CONFFS_fac[i].name,
						strlen(CONFFS_fac[i].name)+1))
				{
					break;
				}
			}

			/* did we not match anything? */
			if(CONFFS_faclen==i)
			{
				snprintf(CONFPRV_errstr,1024,"Unknown facility: %s",yyvsp[0].sval);

				yyerror(CONFPRV_errstr);

				free(yyval.ipntr);
				return 1;		/* return an error */
			}
			/* add our new element */
			else
			{
				yyval.ipntr[CONFFS_fac[i].fs]=1;
			}

			free(yyvsp[0].sval);
		}
    break;
case 38:
#line 724 "confparse.y"
{
			int i;

			yyval.ipntr=emalloc(sizeof(int)*CONFFS_FACCOUNT);
			memset(yyval.ipntr,0,CONFFS_FACCOUNT*sizeof(int));	

			for(i=0;i<CONFFS_FACCOUNT;i++)
				yyval.ipntr[i]=1;
		}
    break;
case 39:
#line 734 "confparse.y"
{
			int i=0;

			if(NULL==yyvsp[0].ipntr)
			{
				yyvsp[0].ipntr=emalloc(sizeof(int)*CONFFS_FACCOUNT);
				memset(yyval.ipntr,0,CONFFS_FACCOUNT*sizeof(int));
			}

			for(i=0;i<CONFFS_faclen;i++)
			{
				if(0==strncmp(yyvsp[-2].sval,CONFFS_fac[i].name,
						strlen(CONFFS_fac[i].name)+1))
				{
					break;
				}
			}

			/* if we went to far, error */
			if(CONFFS_faclen==i)
			{
				snprintf(CONFPRV_errstr,1024,"Unknown facility: %s",yyvsp[-2].sval);
				yyerror(CONFPRV_errstr);

				free(yyvsp[0].ipntr);

				return 1;
			}
			/* add the single element */
			else
			{
				yyvsp[0].ipntr[CONFFS_fac[i].fs]=1;
			}

			free(yyvsp[-2].sval);
			yyval.ipntr=yyvsp[0].ipntr;
		}
    break;
case 40:
#line 775 "confparse.y"
{
			int     i;
            char    *p;
            bool    done;

			yyval.ipntr=emalloc(sizeof(int)*CONFFS_SEVCOUNT);
			memset(yyval.ipntr,0,CONFFS_SEVCOUNT*sizeof(int));

            /* Check for a dash which would make this a range */
            done = FALSE;
            for (p = yyvsp[0].sval; *p != '\0'; p++) 
            {
                if (*p == '-') 
                {
                    *p = '\0';
                    p++;
                    done = TRUE;    /* one way or another... */
                    if (parseSevRange(yyvsp[0].sval, p, yyval.ipntr) != 0) 
                    {
                        free(yyval.ipntr);
                        return 1;
                    }

                }
            }

            if (!done) 
            {

                for(i=0;i<CONFFS_sevlen;i++)
                {
                    if(0==strncmp(yyvsp[0].sval,CONFFS_sev[i].name,
                            strlen(CONFFS_sev[i].name)+1))
                    {
                        break;
                    }
                }

                /* do we have an error? */
                if(CONFFS_sevlen==i)
                {	
                    snprintf(CONFPRV_errstr,1024,"Unknown severity: %s",yyvsp[0].sval);
                    yyerror(CONFPRV_errstr);
                    free(yyval.ipntr);

                    return 1;
                }
                /* add everything less than this */
                else
                {
                    int j=CONFFS_sev[i].fs;
                    int val;

                    DPRINT(DBG_CNF, "sev: .%s is good, adding it", yyvsp[0].sval);

                    /* The 'none' severity tweaks all of them 
                     * Also For a severity of none, we want to flag that all
                     * the associated facilities should be droped, and
                     * not passed.
                     */
                    if (j == CONFFS_NONE) {
                        j = CONFFS_SEVCOUNT - 1;
                        val = PRI_DROP;
                    }
                    else {
                        val = PRI_PASS;
                    }

                    for(;j>=0;j--)
                    {
                        yyval.ipntr[j] = val;
                        DPRINT(DBG_CNF, "sev .%s: %d -> %d",
                            yyvsp[0].sval, j, yyval.ipntr[j]);
                    }
                }
            }
                
			free(yyvsp[0].sval);
		}
    break;
case 41:
#line 855 "confparse.y"
{
			int i;

			yyval.ipntr=emalloc(sizeof(int)*CONFFS_SEVCOUNT);
			memset(yyval.ipntr,0,CONFFS_SEVCOUNT*sizeof(int));

			for(i=0;i<CONFFS_sevlen;i++)
			{
				if(0==strncmp(yyvsp[0].sval,CONFFS_sev[i].name,
						strlen(CONFFS_sev[i].name)+1))
				{
					break;
				}
			}

			/* check for an error */
			if(CONFFS_sevlen==i)
			{
				snprintf(CONFPRV_errstr,1024,"Unknown severity: %s",yyvsp[0].sval);
				yyerror(CONFPRV_errstr);
				free(yyval.ipntr);

				return 1;
			}
            /* A severity of none is considered an error here */
            else if (CONFFS_sev[i].fs == CONFFS_NONE)
            {
                yyerror("usage of '=none' makes no sense");
                free(yyval.ipntr);

                return 1;
            }
			/* else, we just add this one */
			else
			{
				yyval.ipntr[CONFFS_sev[i].fs]=1;
			}

			free(yyvsp[0].sval);
		}
    break;
case 42:
#line 896 "confparse.y"
{
			yyval.ipntr=emalloc(sizeof(int)*8);
			memset(yyval.ipntr,0,8*sizeof(int));

            if (parseSevRange(yyvsp[-2].sval, yyvsp[0].sval, yyval.ipntr) != 0) {
                free(yyval.ipntr);
                return 1;
            }

			free(yyvsp[-2].sval);
			free(yyvsp[0].sval);
		}
    break;
case 43:
#line 909 "confparse.y"
{
			int j=0;

			yyval.ipntr=emalloc(sizeof(int)*8);
			memset(yyval.ipntr,0,8*sizeof(int));

			for(j=CONFFS_DEBUG;j>CONFFS_NONE;j--)
				yyval.ipntr[j]=PRI_PASS;
		}
    break;
case 44:
#line 922 "confparse.y"
{
			yyval.sval=yyvsp[0].sval;
		}
    break;
case 45:
#line 929 "confparse.y"
{
            yyval.ival=yyvsp[-1].ival;
        }
    break;
case 46:
#line 935 "confparse.y"
{
            enum MFOPT   opt;
            opt = MFRMT_getOption(yyvsp[-2].sval);
            if (opt == MFOPT_NOEXIST) 
            {
                snprintf(CONFPRV_errstr, 1024, 
                    "No such formatter option '%s'", yyvsp[-2].sval);
                yyerror(CONFPRV_errstr);

                /* Not fatal */
            }
            else 
            {
                BM_SET(yyvsp[0].ival, opt);
            }
            free(yyvsp[-2].sval);
            yyval.ival = yyvsp[0].ival;
        }
    break;
case 47:
#line 954 "confparse.y"
{
            yyval.ival = 0;
        }
    break;
case 48:
#line 961 "confparse.y"
{
			yyval.sval=yyvsp[0].sval;
		}
    break;
case 49:
#line 965 "confparse.y"
{
			yyval.sval=yyvsp[0].sval;
		}
    break;
case 50:
#line 972 "confparse.y"
{
			yyval.ival=yyvsp[0].ival;
		}
    break;
case 51:
#line 979 "confparse.y"
{
			struct outchan_info *out;
			struct inchan_info *in;

			yyval.connect_conf=CONFOBJ_createCon();

			out=CONFSYM_getOutput(yyvsp[0].sval);
			if(NULL==out)
			{
				snprintf(CONFPRV_errstr,1024,"output type not defined: %s\n",yyvsp[0].sval);
				yyerror(CONFPRV_errstr);

				free(yyvsp[-2].sval);
				free(yyvsp[0].sval);

				return 1;		/* return an error */
			}

			in=CONFSYM_getInput(yyvsp[-2].sval);
			if(NULL==in)
			{
				snprintf(CONFPRV_errstr,1024,"input type not defined: %s\n",yyvsp[-2].sval);
				yyerror(CONFPRV_errstr);

				free(yyvsp[-2].sval);
				free(yyvsp[0].sval);

				return 1;		/* return an error */
			}

			yyval.connect_conf->input=in->name;
			yyval.connect_conf->output=out->name;

			/* only you can prevent memory leaks */
			free(yyvsp[-2].sval);
			free(yyvsp[0].sval);
		}
    break;
case 52:
#line 1020 "confparse.y"
{
			yyval.global_conf=yyvsp[-1].global_conf;
		}
    break;
case 53:
#line 1027 "confparse.y"
{
			if(!CONFPRV_parseGlobal(yyvsp[-3].sval,yyvsp[-2].sval,yyvsp[0].global_conf))
			{
				snprintf(CONFPRV_errstr,1024,"Unknown global: %s",yyvsp[-2].sval);
				yyerror(CONFPRV_errstr);

				return 1;
			}

			yyval.global_conf=yyvsp[0].global_conf;
            free(yyvsp[-3].sval);
		}
    break;
case 54:
#line 1040 "confparse.y"
{
			if(!CONFPRV_parseGlobal(yyvsp[-3].sval,yyvsp[-2].sval,yyvsp[0].global_conf))
			{
				snprintf(CONFPRV_errstr,1024,"Unknown global: %s",yyvsp[-3].sval);
				yyerror(CONFPRV_errstr);

				return 1;
			}

			yyval.global_conf=yyvsp[0].global_conf;
            free(yyvsp[-3].sval);
		}
    break;
case 55:
#line 1053 "confparse.y"
{
            if (!CONFPRV_parseGlobalIntVal(yyvsp[-3].sval, yyvsp[-2].ival, yyvsp[0].global_conf))
            {
                snprintf(CONFPRV_errstr,1024,"Unknown global: %s",yyvsp[-3].sval);
                yyerror(CONFPRV_errstr);

                return 1;
            }
            yyval.global_conf = yyvsp[0].global_conf;
            free(yyvsp[-3].sval);
        }
    break;
case 56:
#line 1065 "confparse.y"
{
			yyval.global_conf=CONFOBJ_createGlobal();
		}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1070 "confparse.y"


#include <stdio.h>

void yyerror(char *s)
{
	if(CONFPRV_fname()!=NULL)
		printf("%s:%d: %s\n",CONFPRV_fname(),CONFPRV_lineno(),s);
	else
		printf("%d: %s\n",CONFPRV_lineno(),s);
}

/* This need access to data private to this file, but also needs to be a
 * function.
 */
int parseSevRange(char const *rstr, char const *lstr, int *pris)
{
    int lower, upper;

    DPRINT(DBG_CNF, "Entering parseSevRange (%s, %s)", rstr, lstr);

    /* Get the two edges of our range */
    for (lower=0; lower < CONFFS_sevlen; lower++) 
    {
        if (strcmp(rstr, CONFFS_sev[lower].name) == 0)
        {
            break;
        }
    }
    for (upper=0; upper < CONFFS_sevlen; upper++)
    {
        if (strcmp(lstr, CONFFS_sev[upper].name) == 0)
        {
            break;
        }
    }

    DPRINT(DBG_CNF, "parseSevRange: lower = %d, upper = %d", 
        lower, upper);

    DPRINT(DBG_CNF, "sev range: %d - %d",
        CONFFS_sev[lower], CONFFS_sev[upper]);

    /* check for an error */
    if(CONFFS_sevlen==lower)
    {   
        snprintf(CONFPRV_errstr,1024,"Unknown severity: %s",rstr);
        yyerror(CONFPRV_errstr);

        return 1;
    }   
    /* check for another error */
    else if(CONFFS_sevlen==upper)
    {   
        snprintf(CONFPRV_errstr,1024,"Unknown severity: %s",lstr);
        yyerror(CONFPRV_errstr);
        return 1;
    }
    /* using 'none' in a range is also an error */
    else if (CONFFS_sev[lower].fs == CONFFS_NONE
        || CONFFS_sev[upper].fs == CONFFS_NONE)
    {
        yyerror("Using 'none' in a range makes no sense");
        return 1;
    }
    /* else, we're good, so add things into the array */
    else
    {
        int i;

        /* swap if needed */
        if (CONFFS_sev[lower].fs > CONFFS_sev[upper].fs) 
        {
            i = upper;
            upper = lower;
            lower = i;
        }
        DPRINT(DBG_CNF, "sev range: %d - %d",
            CONFFS_sev[lower], CONFFS_sev[upper]);

        i = CONFFS_sev[lower].fs;


        for(;i<=CONFFS_sev[upper].fs;i++)
        {
            pris[i]=1;
        }
    }

    return 0;
}
