/**
 * @file ut_acl_crunch.c
 *
 * @brief Define the Base Test suite, and implements it
 * @ingroup ut_acl
 *
 *
 * $Id: ut_acl_crunch.c,v 1.3.2.1 2003/04/30 20:03:43 devink Exp $
 *
 * @author Matt Small <small@sdsc.edu>
 * @date   Tue Apr  2 16:16:22 PST 2002
 *
 * Copyright 2002-2003 
 *     The Regents of the University of California. All Rights Reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 * 
 *     * Neither the name of the The Regents of the University of
 *       California nor the names of its contributors may be used to
 *       endorse or promote products derived from this software without
 *       specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>      /* for NULL */

#include "ut_driver.h"

/* Include all the needed test suite headers */
#include "ut_acl.h"

/* and, include the ACL headers */
#include "util/acl.h"

/**@name ACL Test Cases
 * @ingroup ut_acl
 * @{
 */
/** Crunch tests 
 * @todo Implement this???
 */
static void TESTacl_crunch(void);
/*@}*/

void acl_suite_crunch(Suite *suite)
{
	TCase *tc_io;

	tc_io=tcase_create("ACL_crunch");
	suite_add_tcase(suite,tc_io);
	
	tcase_add_test(tc_io,TESTacl_crunch);
}

START_TEST(TESTacl_crunch)
{
}
END_TEST
