/**
 * @file ut_config.c
 *
 * @brief Define the Base Test suite.  
 * @ingroup ut_config
 *
 *
 * $Id: ut_config.c,v 1.8.2.1 2003/04/30 20:03:46 devink Exp $
 *
 * @author Matt Small <small@sdsc.edu>
 * @date   Fri Apr 12 12:43:52 PDT 2002
 *
 * Copyright 2002-2003 
 *     The Regents of the University of California. All Rights Reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 * 
 *     * Neither the name of the The Regents of the University of
 *       California nor the names of its contributors may be used to
 *       endorse or promote products derived from this software without
 *       specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>      /* for NULL */

#include "ut_driver.h"

/* Include all the needed test suite headers */
#include "config/config.h"
#include "ut_config.h"

/**@defgroup ut_config Configuration File Base Tests
 * @ingroup unit_test
 */


/**@name Globals needed by generic test driver 
 * @ingroup ut_config
 * @{
 */
/* our suite setup functions */
SuiteInfo suites[] = {
	ADD_SUITE(config_object_suite, "Config_Obj"),
	ADD_SUITE(config_symtab_suite, "Config_SymTab"),
	ADD_SUITE(config_read_suite, "Config_Read")
};

int suite_count = SUITE_COUNT;

char const *log_name = "config";

bool disablePrivs = TRUE;
/*@}*/
