/**
 * @file ut_imod.c
 *
 * @brief Input Module Tests
 * @par
 *
 *
 * $Id: ut_imod.c,v 1.3.2.6 2003/04/30 20:03:48 devink Exp $
 *
 * @author Matt Small <small@sdsc.edu>
 * @date   Thu May  9 16:21:54 PDT 2002
 *
 * Copyright 2002-2003 
 *     The Regents of the University of California. All Rights Reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 * 
 *     * Neither the name of the The Regents of the University of
 *       California nor the names of its contributors may be used to
 *       endorse or promote products derived from this software without
 *       specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>

#include "check.h"

#include "ut_imod.h"
#include "ut_driver.h"

/**@name Globals needed by generic test driver
 * @ingroup ut_imod
 * @{
 */
SuiteInfo suites[] = {
	ADD_SUITE(imod_udp_suite, "IMOD_UDP"),
    //ADD_SUITE(imod_mark_suite, "IMOD_MARK"),
#if HAVE_LIBRR
	ADD_SUITE(imod_beep_suite, "IMOD_BEEP"),
	ADD_SUITE(imod_beepck_suite, "IMOD_BEEPCK"),
#endif
};

int suite_count = SUITE_COUNT;

char const *log_name = "imod";

bool disablePrivs = TRUE;
/*@}*/
