/**
 * @file ut_msg_base.c
 *
 * @brief Define the Base Test suite.  
 * @par
 *
 *
 * $Id: ut_msg_base.c,v 1.5.2.6 2003/04/30 20:03:53 devink Exp $
 *
 * @author Devin Kowatch <devink@sdsc.edu>
 * @date   Tue Feb 05 16:51:47 PST 2002
 *
 * Copyright 2002-2003 
 *     The Regents of the University of California. All Rights Reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 * 
 *     * Neither the name of the The Regents of the University of
 *       California nor the names of its contributors may be used to
 *       endorse or promote products derived from this software without
 *       specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>      /* for NULL */

#include "ut_driver.h"

/* Include all the needed test suite headers */
#include "ut_msg_base.h"

/**@defgroup ut_msg Message Base Tests 
 * @ingroup unit_test
 */


/**@name Globals needed by generic test driver 
 * @ingroup ut_msg
 * @{
 */
/* our suite setup functions */
SuiteInfo suites[] = {
	ADD_SUITE(msg_parse_old_suite, "MParser_Old"),
	ADD_SUITE(msg_frmt_read_suite, "MFormatter_Readable"),
    ADD_SUITE(msg_parse_cooked_suite, "MParser_Cooked"),
    ADD_SUITE(msg_frmt_cooked_suite, "MForamtter_Cooked"),
};

int suite_count = SUITE_COUNT;

char const *log_name = "msg";

bool disablePrivs = TRUE;
/*@}*/


